<script lang="ts" setup>
import type { VbenFormSchema } from '#/adapter/form';
import type { EmployeeInfoApi } from '#/api/hr/employeeModel';

import { ref } from 'vue';

import { useVbenModal } from '@vben/common-ui';
import { getVxePopupContainer } from '@vben/utils';

import { useVbenForm } from '#/adapter/form';
import {
  selectDeptNamesByLevel,
  selectDeptNamesByParent,
} from '#/api/hr/employeeDept';
import { applyTransfer } from '#/api/hr/employeeInfo';
import { defaultFormValueGetter, useBeforeCloseDiff } from '#/utils/popup';

const emit = defineEmits<{
  success: [];
}>();
const formData = ref<EmployeeInfoApi.EmployeeTransferApplyBo>();

const formSchema: VbenFormSchema[] = [
  {
    label: '主键',
    fieldName: 'id',
    component: 'Input',
    dependencies: {
      show: () => false,
      triggerFields: [''],
    },
  },
  {
    component: 'Input',
    fieldName: 'name',
    label: '姓名',
    disabled: true,
  },
  {
    component: 'ApiSelect',
    componentProps: (formModel) => ({
      api: async () => {
        const data: string[] = await selectDeptNamesByLevel(1);
        return data.map((item) => ({
          label: item,
          value: item,
        }));
      },
      async onSelect(name: string) {
        /** 根据部门ID加载岗位 */
        await setupDeptLevel2Options(name);
        /** 变化后需要重新选择岗位 */
        formModel.secondLevelDepartment = [];
      },
      getVxePopupContainer,
    }),
    fieldName: 'firstLevelDepartment',
    label: '一级部门',
    rules: 'required',
  },
  {
    component: 'Select',
    componentProps: {
      getVxePopupContainer,
      placeholder: '请先选择一级部门',
    },
    fieldName: 'secondLevelDepartment',
    label: '二级部门',
    rules: 'required',
  },
  // {
  //   component: 'Input',
  //   fieldName: 'description',
  //   label: '描述',
  //   rules: 'required',
  // },
  {
    component: 'Textarea',
    fieldName: 'remark',
    label: '调配申请备注',
    formItemClass: 'items-start',
  },
];

const [BasicForm, formApi] = useVbenForm({
  commonConfig: {
    componentProps: {
      class: 'w-full',
    },
    formItemClass: 'col-span-2',
    labelWidth: 90,
  },
  schema: formSchema,
  showDefaultActions: false,
  wrapperClass: 'grid-cols-2',
});

const { onBeforeClose, markInitialized, resetInitialized } = useBeforeCloseDiff(
  {
    initializedGetter: defaultFormValueGetter(formApi),
    currentGetter: defaultFormValueGetter(formApi),
  },
);

const [BasicModal, modalApi] = useVbenModal({
  fullscreenButton: false,
  onBeforeClose,
  onClosed: handleClosed,
  onConfirm: onSubmit,
  onOpenChange: async (isOpen) => {
    if (!isOpen) {
      return null;
    }
    modalApi.modalLoading(true);

    const data = modalApi.getData() as { id?: number; name?: string };
    if (data) {
      formData.value = data;
      await formApi.setValues(formData.value);
    }
    await markInitialized();

    modalApi.modalLoading(false);
  },
});

async function onSubmit() {
  const { valid } = await formApi.validate();
  if (valid) {
    modalApi.lock();
    const data =
      await formApi.getValues<EmployeeInfoApi.EmployeeTransferApplyBo>();
    try {
      await applyTransfer(data);
      resetInitialized();
      emit('success');
      modalApi.close();
    } finally {
      modalApi.unlock();
    }
  }
}

async function setupDeptLevel2Options(name: string) {
  const deptNameList: string[] = await selectDeptNamesByParent(name);
  const options = deptNameList.map((item) => ({
    label: item,
    value: item,
  }));
  const placeholder = options.length > 0 ? '请选择' : '该部门下暂无岗位';
  formApi.updateSchema([
    {
      componentProps: { options, placeholder },
      fieldName: 'secondLevelDepartment',
    },
  ]);
}

async function handleClosed() {
  await formApi.resetForm();
  resetInitialized();
}

// const getModalTitle = computed(() =>
//   formData.value?.id ? '修改字典类型' : '新增字典类型',
// );
</script>
<template>
  <BasicModal title="调配申请">
    <BasicForm class="mx-4" />
  </BasicModal>
</template>
